> ## Documentation Index
> Fetch the complete documentation index at: https://developers.myhero.so/llms.txt
> Use this file to discover all available pages before exploring further.

# Store an AI key

> Encrypts and stores a vendor API key, and switches that vendor to it.

Replaces any existing key.

Rejects a key that does not look like the named vendor's.



## OpenAPI

````yaml put /ai-keys/{provider}
openapi: 3.1.0
info:
  title: HERO API
  version: current
  description: |-
    The HERO REST API.

    See https://developers.myhero.so for the rendered docs.
servers:
  - url: https://app.myhero.so
security: []
paths:
  /ai-keys/{provider}:
    put:
      tags:
        - AI
      summary: Store an AI key
      description: |-
        Encrypts and stores a vendor API key, and switches that vendor to it.

        Replaces any existing key.

        Rejects a key that does not look like the named vendor's.
      operationId: setAiKey
      parameters:
        - schema:
            type: string
            enum:
              - openai
              - anthropic
          required: true
          name: provider
          in: path
      requestBody:
        content:
          application/json:
            schema:
              type: object
              properties:
                apiKey:
                  type: string
                  minLength: 1
                  maxLength: 500
              required:
                - apiKey
      responses:
        '200':
          description: 200 response
          content:
            application/json:
              schema:
                type: object
                properties:
                  providers:
                    type: array
                    items:
                      type: object
                      properties:
                        provider:
                          type: string
                          enum:
                            - openai
                            - anthropic
                        source:
                          type: string
                          enum:
                            - plan
                            - own_key
                        hasKey:
                          type: boolean
                        lastFour:
                          type: string
                        addedAt:
                          type: number
                        lastVerifiedAt:
                          type: number
                      required:
                        - provider
                        - source
                        - hasKey
                required:
                  - providers
        '400':
          description: 400 response
          content:
            application/json:
              schema:
                type: object
                properties:
                  error:
                    type: string
                    description: |-
                      Error class name (e.g.

                      ValidationError, NotFound)
                  message:
                    type: string
                    description: Human-readable error message
                  details:
                    type: array
                    items: {}
                required:
                  - error
                  - message
        '401':
          description: 401 response
          content:
            application/json:
              schema:
                type: object
                properties:
                  error:
                    type: string
                    description: |-
                      Error class name (e.g.

                      ValidationError, NotFound)
                  message:
                    type: string
                    description: Human-readable error message
                  details:
                    type: array
                    items: {}
                required:
                  - error
                  - message
      security:
        - bearerAuth: []
components:
  securitySchemes:
    bearerAuth:
      type: http
      scheme: bearer
      description: HERO personal access token

````